Attribute VB_Name = "dhHyphenator"
Option Explicit
' MS-Hyphenator v3 (OFF2000,2002,2003,2007) VBA interface
' Library Path for German Version
' https://www.spotlight.de/de/blog/article/1764327/Silben-z%C3%A4hlen-%28Word-2002-SP3%29/

Type LexIn
    lpath As Long
    f1    As Long
    f2    As Long
    lid   As Long
End Type

Type LexOut
    l(5) As Long
End Type

Type HyphDi
    indata(63) As Integer
    f1 As Long
    inchk(63) As Long
End Type

Type HyphPi
    l As Long
    lid As Long
End Type

Type HyphChk
    Data As Long
    param As Long
    flag As Long
    ResH As Long
    ResB As Long
    f1 As Long
    f2 As Long
    f3 As Long
    f4 As Long
End Type

Declare Function HyphenatorVersion Lib "C:\Program Files (x86)\Common Files\Microsoft Shared\PROOF\MSHY3GE.DLL" _
  (ByRef v As Long) As Long
Declare Function HyphenatorInit Lib "C:\Program Files (x86)\Common Files\Microsoft Shared\PROOF\MSHY3GE.DLL" _
  (ByRef h As Long, ByRef v As Long) As Long
Declare Function HyphenatorTerminate Lib "C:\Program Files (x86)\Common Files\Microsoft Shared\PROOF\MSHY3GE.DLL" _
  (ByVal h As Long, ByVal f As Long) As Long
Declare Function HyphenatorOpenLex Lib "C:\Program Files (x86)\Common Files\Microsoft Shared\PROOF\MSHY3GE.DLL" _
  (ByVal h As Long, ByRef li As LexIn, ByRef lo As LexOut) As Long
Declare Function HyphenatorCloseLex Lib "C:\Program Files (x86)\Common Files\Microsoft Shared\PROOF\MSHY3GE.DLL" _
  (ByVal h As Long, ByVal f1 As Long, ByVal f2 As Long) As Long
Declare Function HyphenatorCheck Lib "C:\Program Files (x86)\Common Files\Microsoft Shared\PROOF\MSHY3GE.DLL" _
  (ByVal h As Long, ByRef hi As HyphChk, ByVal ho As Long) As Long
Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
  (pDest As Any, pSource As Any, ByVal cbLength As Long)

Sub Hyphenator(ByRef WordsIn() As String, ByRef sylout() As Long)
    Dim i As Long, v(5) As Long, s As String, j As Long
    Dim h As Long, li As LexIn, lo As LexOut, hc As HyphChk, shl As String
    Dim hdo(255) As Long, hbuf(255) As Long, hdi As HyphDi, hpi As HyphPi
    On Error Resume Next
    i = UBound(WordsIn) < 0 Or UBound(sylout) < 0
    If Err Then Exit Sub
    HyphenatorVersion v(0)
    If v(1) <> &H3000000 Then MsgBox "Error: Wrong or missing HyphenatorVersion": Exit Sub
    If 0 = HyphenatorInit(h, v(1)) Then
        shl = "C:\Program Files (x86)\Common Files\Microsoft Shared\PROOF\MSHY3GEP.LEX" & vbNullChar
        li.lpath = StrPtr(shl)
        li.f2 = 4&
        li.lid = &H407& ' lcid DE
        If 0 = HyphenatorOpenLex(h, li, lo) Then
        For j = 0 To UBound(WordsIn)
            s = WordsIn(j)
            If Len(s) <= 64 Then  ' max word length
                Erase hdi.indata: Erase hdi.inchk
                Erase hdo: Erase hbuf
                CopyMemory hdi.indata(0), ByVal StrPtr(s), 2 * Len(s)
                For i = 0 To Len(s) - 1
                    hdi.inchk(i) = i
                Next i
                hpi.l = lo.l(1)    ' lex id
                hpi.lid = &H407&   ' language lcid: DE
                hc.Data = VarPtr(hdi.indata(0))
                hc.param = VarPtr(hpi.l)
                hc.flag = 1
                hc.ResH = VarPtr(hdo(0))
                hc.ResB = VarPtr(hbuf(0))
                hc.f1 = 0
                hc.f1 = &H42
                If 0 = HyphenatorCheck(h, hc, ByVal VarPtr(hc.ResH)) Then
                    For i = 1 To Len(s)
                        If hdo(i - 1) Then sylout(j) = sylout(j) + 1 ' hyph counter
                    Next i
            Else
                MsgBox "Error: HyphenatorCheck() @ " & s: Exit For
            End If
                Else
                    sylout(j) = 0
                End If
            Next j
            HyphenatorCloseLex h, 4&, 1&
        Else
            MsgBox "Error: HyphenatorOpenLex() " & shl
        End If
        HyphenatorTerminate h, 1&
    End If
End Sub

Public Function HyphenationCount(msg As Boolean) As Long
    Dim w As Range, i As Long, j As Long, sylCount As Long
    With ActiveDocument.Content
        ReDim swi(.Words.Count - 1) As String
        ReDim sylo(.Words.Count - 1) As Long
        For Each w In .Words    ' bilde Wrter-Sammlung
            If Left(w, 1) Like "[A-Za-z]" Then
                swi(i) = Replace(w, Chr(31), vbNullString) ' entferne soft-hyphen
                i = i + 1
            End If
        Next w
    End With
    If i Then
        Hyphenator swi, sylo
        For j = 0 To i - 1  ' Anzahl Wrter
            sylCount = sylCount + sylo(j) + 1 ' summiere Silben (sylo beginnt ab 0)
        Next j
    End If
    If msg Then MsgBox "Die Anzahl der Silben in " & Format(i, "#,##0") _
            & " Wrtern betrgt " & Format(sylCount, "#,##0") & vbCr & _
            "Durchschnittliche Silbenzahl: " & Format(sylCount / i, "#0.00")
    HyphenationCount = sylCount
End Function


