VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} dhLesbarkeit 
   Caption         =   "Analyse der Lesbarkeit"
   ClientHeight    =   3180
   ClientLeft      =   45
   ClientTop       =   390
   ClientWidth     =   3690
   OleObjectBlob   =   "dhLesbarkeit.frx":0000
   ShowModal       =   0   'False
   StartUpPosition =   1  'Fenstermitte
End
Attribute VB_Name = "dhLesbarkeit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim oDoc As Document
Dim idx As Integer, langID As Integer
Dim Worte, Zeichen, Saetze, Absaetze, Silben As Long
Dim Zeichen_pro_Wort, Woerter_pro_Satz, Saetze_pro_Absatz, Mittel_Silben As Single
Dim ASL, ASW, FRE As Single
Dim grenz As Variant, grenzT As Variant, grenzS As Variant, grenzE As Variant

Private Sub UserForm_Initialize()
    Set oDoc = ActiveDocument
    ' Beurteilung der Lesbarkeit
    ' Arrays gem Tabelle 'Flesch-Reading-Ease (deutsch)':
    ' https://de.wikipedia.org/wiki/Lesbarkeitsindex
    
    ' Grenzwerte fr Lesbarkeitsindex (deutsch)
    grenz = Array(30, 50, 60, 70, 80, 90, 100)
    ' Lesbarkeitsbewertung
    grenzT = Array("Sehr schwer", "Schwer", "Mittelschwer", "Mittel", "Mittelleicht", "Leicht", "Sehr leicht")
    grenzS = Array("Akademiker", "", "", "13-15jhriger Schler", "", "", "11jhrige Schler")
    ' Lesbarkeitsbewertung (englisch)
    grenzE = Array("Schwer", "Mittel", "Leicht")
    
    DoEvents
    statistics  'Lesbarkeits-Parameter ermitteln
End Sub

Sub statistics()
    With oDoc
    ' die Parameter des Dokuments
        langID = .Paragraphs(1).Range.LanguageID    'Sprachen-ID
        Zeichen = .Characters.Count
        Worte = .ComputeStatistics(wdStatisticWords)
        Absaetze = .ComputeStatistics(wdStatisticParagraphs)
        Saetze = .Sentences.Count
        Zeichen_pro_Wort = Zeichen / Worte: Zpw.Caption = Format(Zeichen_pro_Wort, "#,##0.00")
        Woerter_pro_Satz = Worte / Saetze: Wps.Caption = Format(Woerter_pro_Satz, "#,##0.00")
        Saetze_pro_Absatz = Saetze / Absaetze: Spa.Caption = Format(Saetze_pro_Absatz, "#,##0.00")
        Silben = HyphenationCount(False)    'Anzahl der Silben ermitteln!!
        Mittel_Silben = Worte / Silben: Msi.Caption = Format(Mittel_Silben, "#,##0.00")
    End With
    'Lesbarkeit berechnen
    ASL = Worte / Saetze
    ASW = Silben / Worte
    If langID = wdGerman Then
        'deutsch
        lblLanguage.Caption = "deutsch"
        FRE = 180 - ASL - (58.5 * ASW)
        idx = caIndexOf(grenz, Int(FRE)) + 1    'Zirka-Index gem Lesbarkeitsindex
        lesText.Caption = grenzT(idx)
        lesS.Caption = grenzS(idx)
    Else
        'englisch
        lblLanguage.Caption = "englisch"
        FRE = 206.835 - (1.015 * ASL) - (84.6 * ASW)
        Select Case FRE
            Case Is >= 60, Is <= 70: idx = 1
            Case Is < 60: idx = 0
            Case Is > 70: idx = 2
        End Select
        lesText.Caption = grenzE(idx)
        lesS.Caption = ""
    End If
    Les.Caption = Format(FRE, "#,##0.00")
End Sub

